IT: OTS (China) - 1100 #441

v4.0: Order list - Step 1
10/29/2024 10:15 AM - Junyi Zhang

Status: aoo Start date: 10/29/2024
Priority: aa Due date: 02/14/2025
Assignee: Junyi Zhang % Done: 100%
Category: Estimated time: 100.00 hours
Target version: v4.0 Spent time: 0.00 hour
Description
Background
1. New requirement for v4.0 OTS
See: OneDrive\l00000000000\Shanghai Group - IMIO0MoTS vall00
Task List
1. List the functions related to the order list No Function D/M R/W Done/To-Do Others
1 My Filter D/M R/W Done valvallfilter
000000000
10000000
my-filter[ ([
va40000000
I
2 Regular D/M R Done DesktopDD
Filter 00000000¢i
Ilters.
3 Current D/M R/W Done W:
Filter 00o00000m
y-filter
4 Current D/M R Done -
Input Date
5 Display D/M R Done goooo
order detail
6 Favorite M R/W Done Mobilel000
gooooodu
pdate order
statusl]
7 Update M R/W Done -
Order
Status
8 Switch M R Done -
compact/full
9 Fold order M R Done Compact:
products 0000000e
Full:
00000009
10 Tracking D/M R Done (Olorder
Info (filter) listll Otrackin
g number
11 Tracking D/M R To-Do Olorder
Info listdDtrackin
(Tracking g number
detail)
12 Download  |M R To-Do Mobile(000
attach files 0000000u
pdate order
statusl]
Mobilel 000
0000000u
pdate order
statusll

13 Upload M
product
images

To-Do

Mobilel 000
0000000u
pdate order
statusll

Mobilel000
0000000u
pdate order
statusl]

14 Display M
Extra info

To-Do

Mobile[l000
0000000u
pdate order
statusl]

Task Details

1. Order list : mobile/desktop
2. Permission Policy :
1. order list - row:

- Admin: 0000
- Retailer: U00000order 0000000000Retailer0000000000Retailerl
- Agent: 00000000 retailerlorder + 00000000productlorder
- Operator: JAgent
2. order list - column:
- Admin: 0000Index, SE date, SE Service
- Retailer: 000 SE date, SE Service (if has_se_info == 1)
- Agent: [IRetailer
- Operator: [IRetailer
3. Retailer filter:
- Admin: 0000
- Retailer: 0000filter
- Agent: Utitter00000000000retailers
- Operator: [Agent
4. has_not_cn:
-has_not_cn = 0 -> J000000(order detail "Not CN")
-has_not_cn =1 -> [0,/00000
5. Sub-account:
- Order detailll l000ratailerl]
- [retailerlll0sub-account
6. SE Status:
-[000/00 SE order status
-[0000000SE order statusll000"Send to customer"
3. Information Pattern (Error, Warning, or notification)
- Form validate
- Loading indicator
- Modal
- Background(red) if [today >= delivery date && Not Completed]

Questions:

1. 00user"Not cN*00000000000000000000,0000000000rder00"Not cN"0000"Not
cN00000000000000000ve000000000000000000v40000000000000000

van: 100000000 = 00000D00C0DOODDOOCODOO

v4 coding standard:

1. Gitll[
#xxx(redmine number): xxx(redmine title) - xxx(JOOOO0O0)

00
2.0000
2.1: 0 Public -> Protected -> Private
ﬁi]z 0000000sBx
3. 000000Modell
3.1: 0000000000modelllsystem(
3.2: v3/vallmodellllOOOOOOON order.php, order_v3.php

I
4. 0000
tDwig, is, css (s, cssU000000essO0M)
5. 0000
|[\|/IVCL (LOenlcn)
6. 00
1.000
/‘k‘k
* @copyright RedBlue-0TS 2024
* @version v4
4
2.00000000 + DOO0O
/**
* @param XXX S$XxX
* @param xxx S$XXX
* @return xxx
*/
Output

e Report and Solution

Others

Related issues:
Copied to 0000 #455: v4.0: Order list - Step 2 0oo 04/21/2025  05/16/2025

History

#1 - 10/29/2024 10:17 AM - Junyi Zhang

Output (2024/11/25 - 2024/11/29), Output (2024/11/18 - 2024/11/22), Output (2024/11/11 - 2024/11/15), Output (2024/11/04 - 2024/11/08), Output
(2024/10/29 - 2024/11/01)

Changes (Desktop):

1. Admin:
1. Update the admin order_status module : (100%)
- Admin dynamic set order status, add 'code'(compatible with V3), and 'hex'(order row background color) fields.
2. Admin add config_order_limit for order list
3. Add 'status’ in admin order statuses module.
4. Add 'config_order_complete_status'. Order list default exclude the order status.
2. Front: (Refer to SBX Ul design)
1. Add common header which should display on the top of every page. (100%)
2. Add not found page (100%)
3. Order list: (100%)
1. Permission: Currently, use v3's permission to filter orders.
- Define some constants in library/user_v3.php for v3's order permission
- We will use these constants before developing the v4 permission system.
2. Filter: Add filters in order list.
- Currently, there are two filter(sort by, input date) and we need add more filter when the Ul is confirm.
3. Use infinite load as pagination method
4. About order status:
- Use new design 8 order statuses and unify with V3
- The v4 new order status(labelled) currently set disable.
- If v3 SE status, it will display 'NG' in order list

Changes (Mobile):

1. Add 'favorite' function by long pressing the 'product&qty’ column
- The popover window about 'favorite/upload photos/download files' has not been designed, so we added 'long press' function directly to
'product&qty' column for now.
2. Add 'update status' function to the 'Update Status' column
- Currently, we have not added any flow limit to update status since the permission and normal/abnormal order have not been designed yet.
- About time-over order(delivery time over): Only update to ‘complete’ status will the time-over warning disappear.
3. Add switch compact/full version order list button in the table's header
- Invisible the first and second of thead as designed and set them as a toolbar area, currently, only one button(switch view(compact/full)) in
this area.
- The switch action will also carry the filters except 'page’ to switch compact/full version.
4. Add 'full' display version of the order list.
- Move the 'favorite' icon to the 'qty’ column in 'full’ version.
5. Reduce the trigger time of long press to increase the user experience
- The old 1s to trigger long press might be too long for the user, so we reduce the time to 500ms for a quicker reaction.

To-do:

1. [Done] Mobile: order list full
2. Mobile: order list compact:
1. 00000 + O0table0000000toodyl0000tbodyl00order(l
2. [Done] favorite(long press)
3. [Done] update order status
4. upload pictures(long press/double click)
5. download files(long press/double click)
6. [Done] Switch compact/full
7. [Done] input/update datelll0: 2024-01-01 -> 24/01/01
8. [Done] loading style: bootstrap -> sbx CSS
3. Mobile: others = header, footer, and so on
4. [Done] Desktop: Add tooltips. Van: D000000000000000000
5. [Done] Common: My filter
6. [Done] Common: Same design as mobile = filters menu, selected filter(+ clear + save)
7.Common: Modal .
8. Common: Scroll to the top [ speciall the first row of the order listl .
9. CommonllLogin
- Add remember me
- [Done] :enter key
10. [Done] Common: Pagination/infinite load instruction (such as "Showing %d of %d" = “Showing 80/970 products” / “80/970 00000
11. Mobile optimization:
1. [Done] Scroll event: scroll refresh, scroll bounce, scroll propagationl]
- A: Disabled the order page's scroll event which valid by class 'non-scroll' set in body.
2. URL address: fold/hidden URL address bar input when scrolling
3. Update status(order list): Update statuslldropdown- menuDDDDDDDDDDDDDDDDDDD
4. [Done] Input date(order filter): |:||:||nput|] mobilelll] pIacehoIderD I
- AlIOS has the placeholder problem(height crash when no date), and now the dafault input date is always set, which means it always has
value in input date.
5. Border sticky(order list): 000000000bug
6. Order list will scroll in two directions.
7. Re-design desktop's the width of the order list
12. Common: (01
1. infinite load
2. popover
- create
- setposition
- etc.
3. select
- search
- reset
- etc.

Important:

1. Permission: Use v3 permission until developing the v4 permission system
- Refer to Task Detail-2 permission.

Database:

1.v4: order status -> Refer to #440
2.v4: order status -> Refer to #440
3. v3: favorite -> Refer to #440
4. v3 default filter -> Refer to #440

#2 - 10/29/2024 11:14 AM - Xihua Fan

- Due date changed from 11/07/2024 to 11/15/2024
- Start date changed from 10/22/2024 to 10/29/2024
- Estimated time set to 100.00 h

#3 - 10/29/2024 11:20 AM - Junyi Zhang
- Description updated

#4 - 10/29/2024 11:32 AM - Junyi Zhang
- Description updated

#5 - 11/05/2024 08:23 PM - Junyi Zhang
- Description updated

#6 - 11/06/2024 09:52 AM - Junyi Zhang
- Description updated

#7 - 11/06/2024 10:12 AM - Junyi Zhang
- % Done changed from 0 to 20

#8 - 11/06/2024 10:14 AM - Junyi Zhang
- Description updated

#9 - 11/06/2024 12:45 PM - Xihua Fan
- Description updated

#10 - 11/06/2024 12:47 PM - Xihua Fan
- Description updated

#11 - 11/06/2024 12:48 PM - Xihua Fan
- Description updated

#12 - 11/06/2024 01:12 PM - Xihua Fan

- Description updated

#13 - 11/06/2024 07:01 PM - Junyi Zhang

- Description updated

#14 - 11/07/2024 11:36 AM - Xihua Fan

- Description updated

#15 - 11/07/2024 01:26 PM - Junyi Zhang

- Description updated

#16 - 11/07/2024 01:41 PM - Junyi Zhang

- Description updated

#17 - 11/07/2024 02:25 PM - Xihua Fan

- Description updated

#18 - 11/07/2024 07:38 PM - Junyi Zhang

- Description updated
#19 - 11/08/2024 11:29 AM - Xihua Fan
- Description updated

#20 - 11/08/2024 01:06 PM - Junyi Zhang
- Description updated

#21 - 11/08/2024 07:39 PM - Junyi Zhang
- Description updated

#22 - 11/08/2024 07:41 PM - Junyi Zhang
- Description updated

#23 - 11/08/2024 07:48 PM - Junyi Zhang
- Description updated

#24 - 11/11/2024 03:20 PM - Junyi Zhang
- Description updated

#25 - 11/11/2024 03:48 PM - Junyi Zhang
- Description updated

#26 - 11/11/2024 07:35 PM - Junyi Zhang
- Description updated

#27 - 11/11/2024 08:13 PM - Junyi Zhang
- Description updated

#28 - 11/12/2024 10:11 AM - Xihua Fan
- Description updated

#29 - 11/12/2024 07:25 PM - Junyi Zhang
- Description updated

#30 - 11/12/2024 07:26 PM - Junyi Zhang
- Description updated

#31 - 11/19/2024 10:18 AM - Xihua Fan
- Description updated

- Due date changed from 11/15/2024 to 11/22/2024

#32 - 11/19/2024 10:38 AM - Junyi Zhang

- Description updated

#33 - 11/19/2024 10:54 AM - Junyi Zhang

- Description updated

#34 - 11/19/2024 11:15 AM - Xihua Fan

- Description updated

#35 - 11/19/2024 02:40 PM - Xihua Fan

- Description updated

#36 - 11/20/2024 07:28 PM - Junyi Zhang

- Description updated

#37 - 11/20/2024 07:48 PM - Xihua Fan
- Description updated

#38 - 11/28/2024 10:28 AM - Junyi Zhang

- Description updated

#39 - 11/28/2024 10:46 AM - Junyi Zhang

- Description updated

#40 - 11/28/2024 12:06 PM - Junyi Zhang

- Description updated

#41 - 11/28/2024 12:20 PM - Xihua Fan

- Description updated

#42 - 12/03/2024 12:11 PM - Junyi Zhang

- Description updated

#43 - 12/03/2024 12:23 PM - Junyi Zhang

- Description updated

#44 - 12/03/2024 12:32 PM - Xihua Fan

- Description updated

#45 - 12/03/2024 01:46 PM - Xihua Fan
- Due date changed from 11/22/2024 to 12/13/2024

#46 - 12/06/2024 07:04 PM - Xihua Fan

- Description updated

#47 - 12/06/2024 07:30 PM - Xihua Fan

- Description updated

#48 - 12/17/2024 12:36 PM - Junyi Zhang
- % Done changed from 20 to 40

Output (2024/12/17 - 2024/12/20), (2024/12/23 - 2024/12/24)
Done:

1. Functions:
1. Common(my filters edit):
1. filter namel0000
2. 00editlD -> filter namel 00
3. 00current filter[] my filters0000000000fiter] my fiterl00000000curren filter menulll
4. 0000fiter000focuslfilter name
5. filter namel0000000000000
6. Active filter nameDUUDDDU‘*’DDDDD—>'*‘, 0oooo-- oo
7. Bugfix:
1. The text input in the filter area is still editable when not in 'EDIT' mode.
2. In EDIT mode, click 'DELETE' will also trigger 'abort filter' alert.
2. Common style:
1. Unify the style of required, readonly in input.
- The class's position is relative to the input with common padding, if the container has another css style(padding), you may need to
customize the position of required/readonly(for example: top, right etc.).
- To use this style, the css class should be 'flex-column required/readonly'.
3. Common order list
1. order listl00000000000000000000000
- desktoplI000checkboxIRIN, indexorder No.00000000O0
- mobilel0000sticky00000000000
2. desktop order listlhover([
3. Bugfixl] mobile sticky10000000000
- Remove the border-collapse: collapse; for order table and replace with border-right as <td>'s border, since the collapse will take the
second <td>'s border as a common border.
4. Mobile: Collapsible order list
- Support collapsible in order list

- 00 Compactl10000600funl000090

- Modify the order list html structure from a single <tbody> to multiple <tbody> which group by order id.(Note: The order products both in the
end of first page and the start of second page still a problem(They will be separated to two order groups).)

2. Optimizations:

1.

Common: Modal:

- 100desktopl000000mobilelslide up0OOOOM

- Modall000000 ajax, parameter

- Extra: 000000000 setCloseTimeout

- 00001. order list no more record. 2. My filters delete filter 3. My filters cancel the edit.

.Common: Scroll to the top.

- Support override and default is for the whole page, you can override it(offset, selector).
- Offset: Scroll offset(the distant from top). Selector: Customize the listened scroll element.

. Mobile: order list

- Update order status: The column of 'Update order status' now supports expand up/down depending on the position of <td>.

. Fixed width of desktop table: Set fixed width to desktop table

- Use 'table-layout: fixed' instead of default 'auto’ and set width separately to columns.

5.10S:

1. URL address: fold/hidden URL address bar input when scrolling
[II]I][II]I]I]DDI][II]I][II]I][ID/[I[Iurll]l]I]I]I]I]I]I][II]I][II]I][II]I]I]I]/I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]paddmg[l[l[lorder||st[||]|][||]|]|]|]
-0000000000D0000000n000000a00Do00a0PwADOODODfooterd sticky theadl ODDO0SBX product cofigurationlll

Questions:

1.00 Oredmine, git log, trellol00000000000000000000000
Vanl00Function titel00000000000git 1og0000000TitledO0Extra updates / Some small stuff / etc.000000000Trenol00000

Redmine/Trello: 00000000000D0DOD
Function:

1.

Git
1.

s W N

g w N

gpoooooo
. 00

0o
Bugfix
Extra (00000000000)

log:00+010

poooooo
. 00

0o
Bugfix
Extra (0000)0

#49 - 12/25/2024 10:56 AM - Xihua Fan
- Due date changed from 12/13/2024 to 12/31/2024

#50 - 01/14/2025 10:35 AM - Junyi Zhang
- Due date changed from 12/31/2024 to 02/14/2025

Output (2025/01/20), (2025/01/13 - 2025/01/17)0 (2025/01/09 - 2025/01/10)

Done:

1. Functions:
1. Common(my filters edit):

1. Move the 'edit filter name' function to the main area.
2. Allow empty input date interval filter and it means filter all orders from oldest to newest.
3. Add 'order status' filter in my-filter

2. Regular filtersl] Add regular filters as temporary filters to order list

1. Override for 'Current Filters', 'Current input date'(Depend on the user's last operation):
2. The 'Regular Filters' will override the 'Current input date' and clear 'Current Filters'.
3. The 'Current Filters' will also clear 'Regular Filters'.
4.'Current input date' will override IN-date in 'Regular Filters' and 'Current Filters', which depend on whether the user's last operation is
'Current Filters' or 'Regular Filters'.
5. (Desktop) Display the 'Regular filters' in the order filter part as a reminder to the user about selected filters.
- The clear All button will be displayed when more than two filters are selected.
- Remove a single one: User can remove one of the selected filters by clicking 'close' button.
- Display the selected filter item after clicking.
6. Do not support draft function.
- Close 'Regular filters' will recover to the last applied filters.
7. (Mobile) Open 'Regular filter' after clicking 'Search' in footer menu or 'PLUS' button after IN-Date.
3. Tracking Info in order list
- Filter order list according to the tracking info, and it will clear all others 'Regular filters' and 'Current filters'.
- (Double click TODO)V3 has 'Tracking' as a flag to decide whether filter or open tracking detail. V4 now just filter and we will re-consider
this after the tracking detail is finished.
2. Optimizations:
1. Dropdown-menull Dropdown-menu commonization
1. Current usages:
- Current filter(Order list).
- Current input list(Order list).
- Update order status(Order list).
- Filter item (My filter).
- Menu(Footer menu).
2. Parameters and functions:
- (required) data-toggle="dropdown"
- (required) data-type: radio/checkbox/date/etc.
- (required) data-search: dropdown-menu's search function.
- (optional) data-selected: selected input value
- (required) data-source: dropdown-menu's items
- (optional) easyDingZhi.common.dropdown.setTitle: set dropdown-menu's title
- (optional) easyDingZhi.common.dropdown.setFooter: set dropdown-menu's footer
- (optional) easyDingZhi.common.dropdown.setExtraClasses: set dropdown-menu's extra classes
(required) easyDingZhi.common.dropdown.create: create dropdown-menu, and support callback().
out data-source, it must be json format and the value should be the following:
(required) value: input's value
- (optional) text: input's text
- (optional) text_icon: input's text icon before text
- (optional) name: input's name attr
- ( )
- )

3.

oo

optional) placeholder: input's placeholder(when input type is not radio/checkbox)
optional) class: input's extra classes
- (optional) hex: input's background-color
4. Modify the expand up/down logic
- Expand down: default
- Expand UP: If the dropdown menu is below half of the screen and there is not enough space to display the entire dropdown menu
5. If drowndown-menu has search function + expand UP
- Set the fixed height of dropdown-menu with the search function when it expands UP to avoid flicking(since the decrease of
dropdown-menu's items) when searching.
2. Tooltip:
1. Add easyDingZhi.common.tooltip for some reminder to the user.
2. Parameters:
- (required)data-toggle="tooltip"
- (required)data-text-tooltip
3. Input type="date"
1.10S <input> 'date’ type's 'calendar' icon disappears and the height will collapse when there is no value.
- Replace the inherited 'calendar’ icon with google icon
- Use fixed height to input

TODO:Order listl 1 TODOI [ #455

1. Functions:
1. Order list: tracking number00000
2. Regular/My filterlldropdwon menu 0000000selected[
3. (Double cIick):DDtracking detail
4. AttachOverflowDetection IMaybe we add a sticky headline that can apply on Dropdown-menull
5. Mobile(long press): upload pictures(long press/double click)
6. Mobile(long press):download files(long press/double click)
2. Optimizations:
1. Default filter order except for ‘Completed' [ll0Order ListlI00Order Status = Completed0000000Fiiter000000
- Order statusllcompletedd00Regular/My filerl0000000Completeddl0statusll
2. Mobile: 00,0000000000000
3. Common: 10000000000000000000rder No.0OODOON
4. Common: 000
- popover
- On hover style for clickable elements (such as underscore, background color, mouse pointer, and so on)

#51 - 01/23/2025 01:04 PM - Junyi Zhang
- % Done changed from 40 to 50

#52 - 02/11/2025 10:30 AM - Xihua Fan
- Subject changed from v4.0: Order list to v4.0: Order list - 1

#53 - 02/11/2025 10:49 AM - Xihua Fan
- Description updated

#54 - 02/11/2025 11:17 AM - Junyi Zhang
- Description updated

#55 - 02/11/2025 11:40 AM - Junyi Zhang
- Description updated

#56 - 02/11/2025 04:28 PM - Junyi Zhang
- Description updated

#57 - 02/11/2025 04:36 PM - Junyi Zhang
- Description updated

#58 - 02/11/2025 05:30 PM - Junyi Zhang
- Copied to0 000 #455: v4.0: Order list - Step 2 added

#59 - 02/11/2025 05:34 PM - Junyi Zhang
- Status changed from 100 to0010
- % Done changed from 50 to 100

#60 - 02/13/2025 04:04 PM - Xihua Fan

- Tracker changed from 00 to0000

#61 - 02/17/2025 06:40 PM - Junyi Zhang

- Description updated

#62 - 11/28/2025 02:42 PM - Xihua Fan

- Subject changed from v4.0: Order list - 1 to v4.0: Order list - Step 1
